<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <parent>
        <groupId>org.springframework.boot</groupId>
        <artifactId>spring-boot-starter-parent</artifactId>
        <version>3.4.1</version>
        <relativePath/>
    </parent>
    
    <groupId>eu.xfsc.cat</groupId>
    <artifactId>fc-service</artifactId>
    <packaging>pom</packaging>
    <!-- Important: The property 'revision' must be updated to describe version changes in a single place for the build process -->
    <version>1.0.0.local</version>

    <name>fc-service</name>
    <description>Eclipse XFSC Federated Catalogue Service</description>
    <organization>
        <name>T-Systems International GmbH</name>
    </organization>

    <repositories>
        <repository>
            <id>danubetech-maven-public</id>
            <url>https://repo.danubetech.com/repository/maven-public/</url>
        </repository>
    </repositories>

    <modules>
        <module>fc-service-api</module>
        <module>fc-service-client</module>
        <module>fc-service-core</module>
        <module>fc-service-server</module>
    </modules>

    <properties>
        <!-- Important: The property 'revision' must be updated to describe version changes in a single place for the build process -->
        <revision>1.3.0-SNAPSHOT</revision>
        <tag.version>latest</tag.version>
        <!-- java -->
        <java.version>17</java.version>
        <maven.compiler.source>17</maven.compiler.source>
        <maven.compiler.target>17</maven.compiler.target>
        <!-- charset -->
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>
        <project.reporting.outputEncoding>UTF-8</project.reporting.outputEncoding>
        <!-- dependencies -->
        <spring.version>6.1.4</spring.version>
        <spring-boot.version>3.4.1</spring-boot.version>
        <springdoc.version>2.8.1</springdoc.version>
        <lombok.version>1.18.30</lombok.version>
        <keycloak.version>23.0.7</keycloak.version>
        <liquibase.version>4.25.1</liquibase.version>
        <jena.version>4.9.0</jena.version>
        <topbraid.version>1.4.2</topbraid.version>
        <vc.version>1.9.0</vc.version>
        <key-format.version>1.15.0</key-format.version>
        <did.version>1.11.0</did.version>
        <ld-signatures.version>1.9.0</ld-signatures.version>
        <uni-resolver.version>0.17.0</uni-resolver.version>
        <titanium.version>1.3.2</titanium.version>
        <caffeine.version>3.1.8</caffeine.version>        
        <eclipse-collections.version>11.1.0</eclipse-collections.version>
        <neo4j.driver.version>5.14.0</neo4j.driver.version>
        <neo4j.gds.version>2.5.6</neo4j.gds.version>
        <neo4j.apoc.version>5.14.0</neo4j.apoc.version>
        <neo4j.neosemantics.version>5.14.0</neo4j.neosemantics.version>
        <bcpkix-jdk18on.version>1.77</bcpkix-jdk18on.version>
        <jnats.version>2.16.13</jnats.version>
        <protobuf-javalite.version>3.25.1</protobuf-javalite.version>
        <jackson-bom.version>2.16.0</jackson-bom.version>
        <commons-compress.version>1.26.0</commons-compress.version>
        <ipaddress.version>5.4.2</ipaddress.version>
        <!-- test libs -->
        <junit-platform.version>1.10.0</junit-platform.version>
        <spring-cloud-contract-wiremock.version>4.1.0</spring-cloud-contract-wiremock.version>
        <security.test-addons.version>4.5.1</security.test-addons.version>
        <embedded.postgres.version>2.0.6</embedded.postgres.version>
        <embedded.postgres.test.version>2.4.0</embedded.postgres.test.version>
        <neo4j.test-harness.version>5.15.0</neo4j.test-harness.version>
        <neo4j.test-spring.version>4.3.6.0</neo4j.test-spring.version>
        <jose4j.version>0.9.3</jose4j.version>
        <okhttp.version>4.12.0</okhttp.version>
        <!-- Allure version -->
        <allure.version>2.20.0</allure.version>
        <!-- plugins -->
        <plugin.jacoco.version>0.8.11</plugin.jacoco.version>
        <plugin.jib.version>3.4.0</plugin.jib.version>
        <plugin.openapi-generator.version>7.1.0</plugin.openapi-generator.version>
        <plugin.maven-license.version>2.4.0</plugin.maven-license.version>
        <plugin.checkstyle.version>3.1.2</plugin.checkstyle.version>
        <plugin.checkstyle.puppycrawl.version>10.3.1</plugin.checkstyle.puppycrawl.version>
        <!-- repoositiry path -->
        <repository.path>eclipse/xfsc/cat/fc-service</repository.path>
        <!--jib-->
        <ci-registry>${env.HARBOR_HOST}/${env.HARBOR_PROJECT}</ci-registry>
    </properties>

    <url>https://gitlab.eclipse.org/${repository.path}</url>
    <scm>
        <connection>scm:git:git://gitlab.eclipse.org/${repository.path}.git</connection>
        <url>https://gitlab.eclipse.org/${repository.path}</url>
        <tag>HEAD</tag>
    </scm>
    <issueManagement>
        <system>GitLab</system>
        <url>https://gitlab.eclipse.org/${repository.path}/-/issues</url>
    </issueManagement>
    <ciManagement>
        <url>https://gitlab.eclipse.org/${repository.path}/-/pipelines</url>
    </ciManagement>

    <dependencyManagement>
        <dependencies>
            <dependency>
                <groupId>eu.xfsc.cat</groupId>
                <artifactId>fc-service-api</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>eu.xfsc.cat</groupId>
                <artifactId>fc-service-client</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>eu.xfsc.cat</groupId>
                <artifactId>fc-test-support</artifactId>
                <version>${project.version}</version>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>eu.xfsc.cat</groupId>
                <artifactId>fc-service-core</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-starter</artifactId>
                <version>${spring-boot.version}</version>
            </dependency>
            <dependency>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-starter-actuator</artifactId>
                <version>${spring-boot.version}</version>
            </dependency>


            <dependency>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-starter-data-neo4j</artifactId>
                <version>${spring-boot.version}</version>
            </dependency>
            <dependency>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-starter-data-jpa</artifactId>
                <version>${spring-boot.version}</version>
            </dependency>
            <dependency>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-starter-web</artifactId>
                <version>${spring-boot.version}</version>
            </dependency>
            <dependency>
                <groupId>org.springframework</groupId>
                <artifactId>spring-tx</artifactId>
                <version>${spring.version}</version>
            </dependency>
            <dependency>
                <groupId>org.springdoc</groupId>
                <artifactId>springdoc-openapi-starter-webmvc-ui</artifactId>
                <version>${springdoc.version}</version>
            </dependency>
            <dependency>
                <groupId>org.projectlombok</groupId>
                <artifactId>lombok</artifactId>
                <optional>true</optional>
                <!--scope>provided</scope-->
                <version>${lombok.version}</version>
            </dependency>
            <dependency>
                <groupId>io.micrometer</groupId>
                <artifactId>micrometer-registry-prometheus</artifactId>
                <version>${micrometer.version}</version>
            </dependency>
            <dependency>
                <groupId>org.keycloak</groupId>
                <artifactId>keycloak-admin-client</artifactId>
                <version>${keycloak.version}</version>
            </dependency>
            <dependency>
                <groupId>org.liquibase</groupId>
                <artifactId>liquibase-core</artifactId>
                <version>${liquibase.version}</version>
            </dependency>
            <dependency>
                <groupId>com.github.ben-manes.caffeine</groupId>
                <artifactId>caffeine</artifactId>
                <version>${caffeine.version}</version>
            </dependency> 
            <dependency>
                <groupId>org.eclipse.collections</groupId>
                <artifactId>eclipse-collections</artifactId>        
                <version>${eclipse-collections.version}</version>
            </dependency>
            <dependency>
                <groupId>com.google.protobuf</groupId>
                <artifactId>protobuf-javalite</artifactId>
                <version>${protobuf-javalite.version}</version>
            </dependency>           
            
            <dependency>
                <groupId>org.neo4j.driver</groupId>
                <artifactId>neo4j-java-driver</artifactId>
                <version>${neo4j.driver.version}</version>
            </dependency>
            <dependency>
                <groupId>org.neo4j</groupId>
                <artifactId>neosemantics</artifactId>
                <version>${neo4j.neosemantics.version}</version>
            </dependency>
            <dependency>
                <groupId>org.neo4j.gds</groupId>
                <artifactId>proc</artifactId>
                <version>${neo4j.gds.version}</version>
            </dependency>
            <dependency>
                <groupId>org.neo4j.gds</groupId>
                <artifactId>open-model-catalog</artifactId>
                <version>${neo4j.gds.version}</version>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>org.neo4j.procedure</groupId>
                <artifactId>apoc-core</artifactId>
                <version>${neo4j.apoc.version}</version>
            </dependency>
            <dependency>
                <groupId>org.neo4j.driver</groupId>
                <artifactId>neo4j-java-driver-test-harness-spring-boot-autoconfigure</artifactId>
                <version>${neo4j.test-spring.version}</version>
            </dependency>
            <dependency>
                <groupId>org.neo4j.test</groupId>
                <artifactId>neo4j-harness</artifactId>
                <version>${neo4j.test-harness.version}</version>
                <exclusions>
                    <exclusion>
                        <groupId>org.slf4j</groupId>
                        <artifactId>slf4j-nop</artifactId>
                    </exclusion>
                    <exclusion>
                        <groupId>org.neo4j</groupId>
                        <artifactId>neo4j-slf4j-provider</artifactId>
                    </exclusion>
                </exclusions>
            </dependency>
            
            <dependency>
                <groupId>org.apache.jena</groupId>
                <artifactId>apache-jena-libs</artifactId>
                <version>${jena.version}</version>
                <type>pom</type>
            </dependency>
            <dependency>
                <groupId>org.topbraid</groupId>
                <artifactId>shacl</artifactId>
                <version>${topbraid.version}</version>
                <exclusions>
                    <exclusion>
                        <groupId>org.apache.jena</groupId>
                        <artifactId>jena-arq</artifactId>
                    </exclusion>
                </exclusions>                
            </dependency>
            <dependency>
                <groupId>com.apicatalog</groupId>
                <artifactId>titanium-json-ld</artifactId>
                <version>${titanium.version}</version>
            </dependency>
            <dependency>
                <groupId>com.danubetech</groupId>
                <artifactId>verifiable-credentials-java</artifactId>
                <version>${vc.version}</version>
            </dependency>
            <dependency>
                <groupId>com.danubetech</groupId>
                <artifactId>key-formats-java</artifactId>
                <version>${key-format.version}</version>
            </dependency>
            <dependency>
                <groupId>decentralized-identity</groupId>
                <artifactId>did-common-java</artifactId>
                <version>${did.version}</version>
            </dependency>
            <dependency>
	            <groupId>decentralized-identity</groupId>
	            <artifactId>uni-resolver-client</artifactId>
	            <version>${uni-resolver.version}</version>
            </dependency>
            <dependency>
                <groupId>info.weboftrust</groupId>
                <artifactId>ld-signatures-java</artifactId>
                <version>${ld-signatures.version}</version>
            </dependency>
            <dependency>
                <groupId>io.nats</groupId>
                <artifactId>jnats</artifactId>
                <version>${jnats.version}</version>
            </dependency>
            <dependency>
                <groupId>org.bouncycastle</groupId>
                <artifactId>bcpkix-jdk18on</artifactId>
                <version>${bcpkix-jdk18on.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.commons</groupId>
                <artifactId>commons-compress</artifactId>
                <version>${commons-compress.version}</version>
            </dependency>
            <dependency>
                <groupId>com.github.seancfoley</groupId>
                <artifactId>ipaddress</artifactId>
                <version>${ipaddress.version}</version>
            </dependency>

            <!-- Test dependencies -->
            <dependency>
                <groupId>org.junit.platform</groupId>
                <artifactId>junit-platform-launcher</artifactId>
                <version>${junit-platform.version}</version>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>org.junit.jupiter</groupId>
                <artifactId>junit-jupiter</artifactId>
                <version>${junit-jupiter.version}</version>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-starter-test</artifactId>
                <version>${spring-boot.version}</version>
                <scope>test</scope>
                <exclusions>
					<exclusion>
                        <groupId>com.vaadin.external.google</groupId>
                        <artifactId>android-json</artifactId>
					</exclusion>
				</exclusions>
            </dependency>
            <dependency>
                <groupId>io.zonky.test</groupId>
                <artifactId>embedded-postgres</artifactId>
                <version>${embedded.postgres.version}</version>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>io.zonky.test</groupId>
                <artifactId>embedded-database-spring-test</artifactId>
                <version>${embedded.postgres.test.version}</version>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>org.springframework.cloud</groupId>
                <artifactId>spring-cloud-contract-wiremock</artifactId>
                <version>${spring-cloud-contract-wiremock.version}</version>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>org.bitbucket.b_c</groupId>
                <artifactId>jose4j</artifactId>
                <version>${jose4j.version}</version>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>com.squareup.okhttp3</groupId>
                <artifactId>okhttp</artifactId>
                <version>${okhttp.version}</version>
                <scope>test</scope>
            </dependency>
            <dependency>
                <groupId>com.squareup.okhttp3</groupId>
                <artifactId>mockwebserver</artifactId>
                <version>${okhttp.version}</version>
                <scope>test</scope>
            </dependency>

			<!-- Allure Dependencies -->
			<dependency>
				<groupId>io.qameta.allure</groupId>
				<artifactId>allure-bom</artifactId>
				<version>${allure.version}</version>
				<type>pom</type>
				<scope>import</scope>
			</dependency>

        </dependencies>
    </dependencyManagement>

    <build>
        <pluginManagement>
            <plugins>
                <plugin>
                    <groupId>org.apache.maven.plugins</groupId>
                    <artifactId>maven-jar-plugin</artifactId>
                    <configuration>
                        <archive>
                            <manifest>
                                <addDefaultImplementationEntries>true</addDefaultImplementationEntries>
                            </manifest>
                        </archive>
                    </configuration>
                </plugin>
                <plugin>
                    <groupId>org.apache.maven.plugins</groupId>
                    <artifactId>maven-checkstyle-plugin</artifactId>
                    <version>${plugin.checkstyle.version}</version>
                    <dependencies>
                        <dependency>
                            <groupId>com.puppycrawl.tools</groupId>
                            <artifactId>checkstyle</artifactId>
                            <version>${plugin.checkstyle.puppycrawl.version}</version>
                        </dependency>
                    </dependencies>
                </plugin>
                <plugin>
                    <groupId>org.apache.maven.plugins</groupId>
                    <artifactId>maven-compiler-plugin</artifactId>
                </plugin>
                <plugin>
                    <groupId>org.codehaus.mojo</groupId>
                    <artifactId>license-maven-plugin</artifactId>
                    <version>${plugin.maven-license.version}</version>
                </plugin>
                <plugin>
                    <groupId>org.apache.maven.plugins</groupId>
                    <artifactId>maven-resources-plugin</artifactId>
                </plugin>
                <plugin>
                    <groupId>org.jacoco</groupId>
                    <artifactId>jacoco-maven-plugin</artifactId>
                    <version>${plugin.jacoco.version}</version>
                </plugin>
                <plugin>
                    <groupId>org.springframework.boot</groupId>
                    <artifactId>spring-boot-maven-plugin</artifactId>
                    <version>${spring-boot.version}</version>
                </plugin>
                <plugin>
                    <groupId>org.owasp</groupId>
                    <artifactId>dependency-check-maven</artifactId>
                </plugin>
                <plugin>
                    <groupId>org.openapitools</groupId>
                    <artifactId>openapi-generator-maven-plugin</artifactId>
                    <version>${plugin.openapi-generator.version}</version>
                    <configuration>
                        <generateApiTests>false</generateApiTests>
                        <generateModelTests>false</generateModelTests>
                        <generateApiDocumentation>false</generateApiDocumentation>
                        <generateModelDocumentation>false</generateModelDocumentation>
                        <configOptions>
                            <!--serializableModel>true</serializableModel-->
                            <useSwaggerUI>true</useSwaggerUI>
                            <useSpringBoot3>true</useSpringBoot3>
                        </configOptions>
                    </configuration>
                </plugin>
                <plugin>
                    <groupId>com.google.cloud.tools</groupId>
                    <artifactId>jib-maven-plugin</artifactId>
                    <version>${plugin.jib.version}</version>
                    <configuration>
                        <container>
						    <!-- ${maven.build.timestamp} should work also -->
                            <creationTime>USE_CURRENT_TIMESTAMP</creationTime>
                        </container>
                        <from>
                            <image>gcr.io/distroless/java17-debian12</image>
                        </from>
                        <!-- Turn it off for all the modules, but
                            turn it on in server module only -->
                        <skip>true</skip>
                    </configuration>
                </plugin>

            </plugins>
        </pluginManagement>

        <plugins>
            <plugin>
                <groupId>org.apache.maven.plugins</groupId>
                <artifactId>maven-compiler-plugin</artifactId>
                <configuration>
                    <annotationProcessorPaths>
                        <path>
                            <groupId>org.projectlombok</groupId>
                            <artifactId>lombok</artifactId>
                            <version>${lombok.version}</version>
                        </path>
                    </annotationProcessorPaths>
                </configuration>
            </plugin>
            <plugin>
                <groupId>org.codehaus.mojo</groupId>
                <artifactId>license-maven-plugin</artifactId>
                <configuration>
                    <includes>**/*.java</includes>
                    <copyrightOwners>${project.organization.name} and all other contributors</copyrightOwners>
                    <processStartTag>---license-start</processStartTag>
                    <processEndTag>---license-end</processEndTag>
                    <sectionDelimiter>---</sectionDelimiter>
                    <addJavaLicenseAfterPackage>false</addJavaLicenseAfterPackage>
                    <trimHeaderLine>true</trimHeaderLine>
                    <emptyLineAfterHeader>true</emptyLineAfterHeader>
                    <outputDirectory>.</outputDirectory>
                    <thirdPartyFilename>THIRD-PARTY.txt</thirdPartyFilename>
                    <!--fileTemplate>templates/third-party.ftl</fileTemplate-->
                    <!--excludedArtifacts>dgc-lib</excludedArtifacts-->
                </configuration>
            </plugin>

            <plugin>
                <groupId>org.jacoco</groupId>
                <artifactId>jacoco-maven-plugin</artifactId>
                <version>0.8.12</version>
                <executions>
                    <execution>
                        <goals>
                            <goal>prepare-agent</goal>
                        </goals>
                    </execution>
                    <execution>
                        <id>report</id>
                        <phase>test</phase>
                        <goals>
                            <goal>report</goal>
                        </goals>
                    </execution>
                </executions>
            </plugin>
        </plugins>
    </build>
</project>
